| Elektra 0.11.0

ksDel

- start = 2021-03-09 02:10
- end = 2021-03-09 02:20
- reviewer = Stefan Hanreich stefa.nosp@m.nhan.nosp@m.i@gma.nosp@m.il.c.nosp@m.om

# Signature

`int ksDel(KeySet *ks)`

# Checklist

### Doxygen

(bullet points are in order of appearance)

- [x] First line explains briefly what the function does
- [ ] Simple example or snippet how to use the function
  - [ ] add
- [x] Longer description of function containing common use cases
- [ ] Description of functions reads nicely
  - [ ] fix `elektraFree()` ref
  - [ ] 'the release the'
- [ ] `@pre`
  - [ ] add
- [ ] `@post`
  - [ ] add
- [ ] `@invariant`
  - [ ] add
- [x] `@param` for every parameter
- [x] `@return` / `@retval`
- [ ] `@since`
  - [ ] add
- [ ] `@ingroup`
  - [ ] add
- [x] `@see`

## Naming

- [ ] Abbreviations used in function names must be defined in the Glossary
  - [ ] define `ks`
- [x] Function names should neither be too long, nor too short
- [x] Function name should be clear and unambiguous
- [ ] Abbreviations used in parameter names must be defined in the Glossary
  - [ ] define `ks`
- [x] Parameter names should neither be too long, nor too short
- [x] Parameter names should be clear and unambiguous - [ ] ks -> keySet

## Compatibility

(only in PRs)

- Symbol versioning is correct for breaking changes
- ABI/API changes are forward-compatible (breaking backwards-compatibility to add additional symbols is fine)

## Parameter & Return Types

- Function parameters should use enum types instead of boolean types wherever sensible
- [x] Wherever possible, function parameters should be `const`
- [x] Wherever possible, return types should be `const`
- [x] Functions should have the least amount of parameters feasible

## Structural Clarity

- [x] Functions should do exactly one thing
- [x] Function name has the appropriate prefix
- [ ] Order of signatures in kdb.h.in is the same as Doxygen
  - [ ] fix
- [x] No functions with similar purpose exist

## Memory Management

- [x] Memory Management should be handled by the function wherever possible

## Extensibility

- [x] Function is easily extensible, e.g., with flags
- [x] Documentation does not impose limits, that would hinder further extensions

## Tests

- [x] Function code is fully covered by tests
- [ ] All possible error states are covered by tests
  - [x] add test for `keyset == NULL`
- All possible enum values are covered by tests
- [x] No inconsistencies between tests and documentation

# Summary

# Other Issues discovered (unrelated to function)